#encoding: utf-8

if StatisticIndex.count == 0
  StatisticIndex.create!([
     {id:1, es_type_key:'subscription', label:'Abonnements'},
     {id:2, es_type_key:'machine', label:'Heures machines'},
     {id:3, es_type_key:'training', label:'Formations'},
     {id:4, es_type_key:'event', label:'Ateliers/Stages'},
     {id:5, es_type_key:'account', label:'Inscriptions', ca: false},
     {id:6, es_type_key:'project', label:'Projets', ca: false},
     {id:7, es_type_key:'user', label:'Utilisateurs', table: false, ca: false}
  ])
  connection = ActiveRecord::Base.connection
  if connection.instance_values["config"][:adapter] == 'postgresql'
    connection.execute("SELECT setval('statistic_indices_id_seq', 7);")
  end
end

if StatisticField.count == 0
  StatisticField.create!([
    # available data_types : index, number, date, text, list
    {key:'trainingId', label:'ID Formation', statistic_index_id: 3, data_type: 'index'},
    {key:'trainingDate', label:'Date Formation', statistic_index_id: 3, data_type: 'date'},
    {key:'eventId', label:'ID Évènement', statistic_index_id: 4, data_type: 'index'},
    {key:'eventDate', label:'Date Évènement', statistic_index_id: 4, data_type: 'date'},
    {key:'themes', label:'Thèmes', statistic_index_id: 6, data_type: 'list'},
    {key:'components', label:'Composants', statistic_index_id: 6, data_type: 'list'},
    {key:'machines', label:'Machines', statistic_index_id: 6, data_type: 'list'},
    {key:'name', label:'Nom Évènement', statistic_index_id: 4, data_type: 'text'},
    {key:'userId', label:'ID Utilisateur', statistic_index_id: 7, data_type: 'index'}
  ])
end

unless StatisticField.find_by(key:'groupName').try(:label)
  field = StatisticField.find_or_initialize_by(key: 'groupName')
  field.label = 'Groupe'
  field.statistic_index_id = 1
  field.data_type = 'text'
  field.save!
end

if StatisticType.count == 0
  StatisticType.create!([
    {statistic_index_id: 2, key: 'booking', label:'Réservations', graph: true, simple: true},
    {statistic_index_id: 2, key: 'hour', label:"Nombre d'heures", graph: true, simple: false},
    {statistic_index_id: 3, key: 'booking', label:'Réservations', graph: false, simple: true},
    {statistic_index_id: 3, key: 'hour', label:"Nombre d'heures", graph: false, simple: false},
    {statistic_index_id: 4, key: 'booking', label:'Nombre de places', graph: false, simple: false},
    {statistic_index_id: 4, key: 'hour', label:"Nombre d'heures", graph: false, simple: false},
    {statistic_index_id: 5, key: 'member', label:'Utilisateurs', graph: true, simple: true},
    {statistic_index_id: 6, key: 'project', label:'Projets', graph: false, simple: true},
    {statistic_index_id: 7, key: 'revenue', label:"Chiffre d'affaires", graph: false, simple: false}
  ])
end

if StatisticSubType.count == 0
  StatisticSubType.create!([
    {key: 'Stage', label:'Stage', statistic_types: StatisticIndex.find_by(es_type_key: 'event').statistic_types},
    {key: 'Atelier', label:'Atelier', statistic_types: StatisticIndex.find_by(es_type_key: 'event').statistic_types},

    {key: 'created', label:'Création de compte', statistic_types: StatisticIndex.find_by(es_type_key: 'account').statistic_types},
    {key: 'published', label:'Publication de projet', statistic_types: StatisticIndex.find_by(es_type_key: 'project').statistic_types}
  ])
end

if StatisticGraph.count == 0
  StatisticGraph.create!([
    {statistic_index_id:1, chart_type:'stackedAreaChart', limit:0},
    {statistic_index_id:2, chart_type:'stackedAreaChart', limit:0},
    {statistic_index_id:3, chart_type:'discreteBarChart', limit:10},
    {statistic_index_id:4, chart_type:'discreteBarChart', limit:10},
    {statistic_index_id:5, chart_type:'lineChart', limit:0},
    {statistic_index_id:7, chart_type:'discreteBarChart', limit:10}
  ])
end

if Group.count == 0
  Group.create!([
    {name: "standard, association", slug: "standard"},
    {name: "étudiant, - de 25 ans, enseignant, demandeur d'emploi", slug: "student"},
    {name: "artisan, commerçant, chercheur, auto-entrepreneur", slug: "merchant"},
    {name: "PME, PMI, SARL, SA", slug: "business"}
  ])
end

# Create the admin if it does not exist yet
if User.find_by(email: "admin@fab-manager.com").nil?
    admin = User.new(username: 'admin', email: 'admin@fab-manager.com', password: 'adminadmin', password_confirmation: 'adminadmin', group_id: Group.first.id,
                     profile_attributes: {first_name: 'admin', last_name: 'admin', gender: true, phone: '0123456789', birthday: Time.now})
    admin.add_role "admin"
    admin.save
end

if Component.count == 0
  Component.create!([
    {name: "Silicone"},
    {name: "Vinyle"},
    {name: "Bois Contre plaqué"},
    {name: "Bois Medium"},
    {name: "Plexi / PMMA"},
    {name: "Flex"},
    {name: "Vinyle"},
    {name: "Parafine"},
    {name: "Fibre de verre"},
    {name: "Résine"}
  ])
end

if Licence.count == 0
  Licence.create!([
    {name: "Attribution (BY)", description: "Le titulaire des droits autorise toute exploitation de l’œuvre, y compris à des fins commerciales, ainsi que la création d’œuvres dérivées, dont la distribution est également autorisé sans restriction, à condition de l’attribuer à son l’auteur en citant son nom. Cette licence est recommandée pour la diffusion et l’utilisation maximale des œuvres."},
    {name: "Attribution + Pas de modification (BY ND)", description: "Le titulaire des droits autorise toute utilisation de l’œuvre originale (y compris à des fins commerciales), mais n’autorise pas la création d’œuvres dérivées."},
    {name: "Attribution + Pas d'Utilisation Commerciale + Pas de Modification (BY NC ND)", description: "Le titulaire des droits autorise l’utilisation de l’œuvre originale à des fins non commerciales, mais n’autorise pas la création d’œuvres dérivés."},
    {name: "Attribution + Pas d'Utilisation Commerciale (BY NC)", description: "Le titulaire des droits autorise l’exploitation de l’œuvre, ainsi que la création d’œuvres dérivées, à condition qu’il ne s’agisse pas d’une utilisation commerciale (les utilisations commerciales restant soumises à son autorisation)."},
    {name: "Attribution + Pas d'Utilisation Commerciale + Partage dans les mêmes conditions (BY NC SA)", description: "Le titulaire des droits autorise l’exploitation de l’œuvre originale à des fins non commerciales, ainsi que la création d’œuvres dérivées, à condition qu’elles soient distribuées sous une licence identique à celle qui régit l’œuvre originale."},
    {name: "Attribution + Partage dans les mêmes conditions (BY SA)", description: "Le titulaire des droits autorise toute utilisation de l’œuvre originale (y compris à des fins commerciales) ainsi que la création d’œuvres dérivées, à condition qu’elles soient distribuées sous une licence identique à celle qui régit l’œuvre originale. Cette licence est souvent comparée aux licences « copyleft » des logiciels libres. C’est la licence utilisée par Wikipedia."}
  ])
end

if Theme.count == 0
  Theme.create!([
    {name: "Vie quotidienne"},
    {name: "Robotique"},
    {name: "Arduine"},
    {name: "Capteurs"},
    {name: "Musique"},
    {name: "Sport"},
    {name: "Autre"}
  ])
end

if Training.count == 0
  Training.create!([
    {name: "Formation Imprimante 3D"},
    {name: "Formation Laser / Vinyle"},
    {name: "Formation Petite fraiseuse numerique"},
    {name: "Formation Shopbot Grande Fraiseuse"},
    {name: "Formation logiciel 2D"}
  ])

  TrainingsPricing.all.each do |p|
    p.update_columns(amount: (rand()*50+5).floor*100)
  end
end

if Machine.count == 0
  Machine.create!([
    {name: "Découpeuse laser", description: "Préparation à l'utilisation de l'EPILOG Legend 36EXT\r\nInformations générales    \r\n      Pour la découpe, il suffit d'apporter votre fichier vectorisé type illustrator, svg ou dxf avec des \"lignes de coupe\" d'une épaisseur inférieur à 0,01 mm et la machine s'occupera du reste!\r\n     La gravure est basée sur le spectre noir et blanc. Les nuances sont obtenues par différentes profondeurs de gravure correspondant aux niveaux de gris de votre image. Il suffit pour cela d'apporter une image scannée ou un fichier photo en noir et blanc pour pouvoir reproduire celle-ci sur votre support! \r\nQuels types de matériaux pouvons nous graver/découper?\r\n     Du bois au tissu, du plexiglass au cuir, cette machine permet de découper et graver la plupart des matériaux sauf les métaux. La gravure est néanmoins possible sur les métaux recouverts d'une couche de peinture ou les aluminiums anodisés. \r\n        Concernant l'épaisseur des matériaux découpés, il est préférable de ne pas dépasser 5 mm pour le bois et 6 mm pour le plexiglass.\r\n", spec: "Puissance: 40W\r\nSurface de travail: 914x609 mm \r\nEpaisseur maximale de la matière: 305mm\r\nSource laser: tube laser type CO2\r\nContrôles de vitesse et de puissance: ces deux paramètres sont ajustables en fonction du matériau (de 1% à 100%) .\r\n", slug: "decoupeuse-laser"},
    {name: "Découpeuse vinyle", description: "Préparation à l'utilisation de la Roland CAMM-1 GX24\r\nInformations générales        \r\n     Envie de réaliser un tee shirt personnalisé ? Un sticker à l'effigie votre groupe préféré? Un masque pour la réalisation d'un circuit imprimé? Pour cela, il suffit simplement de venir avec votre fichier vectorisé (ne pas oublier de vectoriser les textes) type illustrator svg ou dxf.\r\n \r\nMatériaux utilisés:\r\n    Cette machine permet de découper principalement du vinyle,vinyle réfléchissant, flex.\r\n", spec: "Largeurs de support acceptées: de 50 mm à 700 mm\r\nVitesse de découpe: 50 cm/sec\r\nRésolution mécanique: 0,0125 mm/pas\r\n", slug: "decoupeuse-vinyle"},
    {name: "Shopbot / Grande fraiseuse", description: "La fraiseuse numérique ShopBot PRS standard\r\nInformations générales\r\nCette machine est un fraiseuse 3 axes idéale pour l'usinage de pièces de grandes dimensions. De la réalisation d'une chaise ou d'un meuble jusqu'à la construction d'une maison ou d'un assemblage immense, le ShopBot ouvre de nombreuses portes à votre imagination! \r\nMatériaux usinables\r\nLes principaux matériaux usinables sont le bois, le plastique, le laiton et bien d'autres.\r\nCette machine n'usine pas les métaux.\r\n", spec: "Surface maximale de travail: 2440x1220x150 (Z) mm\r\nLogiciel utilisé: Partworks 2D & 3D\r\nRésolution mécanique: 0,015 mm\r\nPrécision de la position: +/- 0,127mm\r\nFormats acceptés: DXF, STL \r\n", slug: "shopbot-grande-fraiseuse"},
    {name: "Imprimante 3D", description: "L'utimaker est une imprimante 3D  low cost utilisant une technologie FFF (Fused Filament Fabrication) avec extrusion thermoplastique.\r\nC'est une machine idéale pour réaliser rapidement des prototypes 3D dans des couleurs différentes.\r\n", spec: "Surface maximale de travail: 210x210x220mm \r\nRésolution méchanique: 0,02 mm \r\nPrécision de position: +/- 0,05 \r\nLogiciel utilisé: Cura\r\nFormats de fichier acceptés: STL \r\nMatériaux utilisés: PLA (en stock).", slug: "imprimante-3d"},
    {name: "Petite Fraiseuse", description: "La fraiseuse numérique Roland Modela MDX-20\r\nInformations générales\r\nCette machine est utilisée  pour l'usinage et le scannage 3D de précision. Elle permet principalement d'usiner des circuits imprimés et des moules de petite taille. Le faible diamètre des fraises utilisées (Ø 0,3 mm à  Ø 6mm) induit que certains temps d'usinages peuvent êtres long (> 12h), c'est pourquoi cette fraiseuse peut être laissée en autonomie toute une nuit afin d'obtenir le plus précis des usinages au FabLab.\r\nMatériaux usinables:\r\nLes principaux matériaux usinables sont le bois, plâtre, résine, cire usinable, cuivre.\r\n", spec: "Taille du plateau X/Y : 220 mm x 160 mm\r\nVolume maximal de travail: 203,2 mm (X), 152,4 mm (Y), 60,5 mm (Z)\r\nPrécision usinage: 0,00625 mm\r\nPrécision scannage: réglable de 0,05 à 5 mm (axes X,Y) et 0,025 mm (axe Z)\r\nVitesse d'analyse (scannage): 4-15 mm/sec\r\n \r\n \r\nLogiciel utilisé pour le fraisage: Roland Modela player 4 \r\nLogiciel utilisé pour l'usinage de circuits imprimés: Cad.py (linux)\r\nFormats acceptés: STL,PNG 3D\r\nFormat d'exportation des données scannées: DXF, VRML, STL, 3DMF, IGES, Grayscale, Point Group et BMP\r\n", slug: "petite-fraiseuse"},
    {name: "FORM1+ imprimante 3D", description: "Form 1+, imprimante 3D stéréolithographie.\n\nLa photopolymérisation est le premier procédé de prototypage rapide à avoir été développé dans les années 1980. Le nom de SLA (pour StereoLithography Apparatus) lui a été donné. Il repose sur les propriétés qu'ont certaines résines à se polymériser sous l'effet de la lumière et de la chaleur. (Source : <a href=\"http://fr.wikipedia.org/wiki/St%C3%A9r%C3%A9olithographie\" target=\"_blank\"> wikipédia</a>)\n\n<i>Possibilité d'utiliser 3 résines de couleurs différentes au Lab : noir, blanc et translucide.</i>\n\n<a href=\"http://formlabs.com/fr/products/materials/standard/\" Title=\"http://formlabs.com/fr/products/materials/standard/\" target=\"_blank\">Plus d'infos sur le site web de Formlab</a>", spec: "Imprimante :\n- Dimensions : 30 × 28 × 45 cm\n- Poids : 8 kg\n- Température d'utilisation : 18–28° C\n- Alimentation : 100–240 V ; 1.5 A 50/60 Hz ; 60 W.\n\nCaractéristiques du laser :\n- EN 60825-1:2007 certifié\n- Class 1 Laser Product\n- 405nm violet laser\n\nPropriétés d'impression :\n- Technologie stéréolithographie (SLA)\n- Volume d'impression : 125 × 125 × 165 mm\n- Dimension minimale : 300 microns\n- Épaisseur des couches (Résolution verticale) : 25, 50, 100 microns\n- Ressources Générées automatiquement\n- Facilement amovible", slug: "form1-imprimante-3d"}
  ])

  Price.all.each do |p|
    p.update_columns(amount: (rand()*50+5).floor*100)
  end
end

# if Plan.count == 0
#   Group.all.each do |group|
#     %w(month year).each do |interval|
#       Plan.create!(base_name: "plan #{SecureRandom.hex(4)}", amount: (rand()*200+50).floor*100, interval: interval, group: group)
#     end
#   end
# end

if Category.count == 0
  Category.create!([
    {name: "Stage"},
    {name: "Atelier"}
  ])
end

unless Setting.find_by(name: 'about_body').try(:value)
  setting = Setting.find_or_initialize_by(name: 'about_body')
  setting.value = "<p>Le Fab Lab de <a href=\"http://lacasemate.fr\" target=\"_blank\">La Casemate</a> est un"+
  " atelier de fabrication numérique où l’on peut utiliser des machines de découpe, des imprimantes 3D,… permettant"+
  " de travailler sur des matériaux variés : plastique, bois, carton, vinyle, … afin de créer toute sorte d’objet grâce"+
  " à la conception assistée par ordinateur ou à l’électronique.  Mais le Fab Lab est aussi un lieu d’échange de"+
  " compétences technique. </p>"+
  " <p>Le Fab Lab de <a href=\"http://lacasemate.fr\" target=\"_blank\">La Casemate</a> est un espace"+
  " permanent : ouvert à tous, il offre la possibilité de réaliser des objets soi-même, de partager ses"+
  " compétences et d’apprendre au contact des médiateurs du Fab Lab et des autres usagers. </p>"+
  "<p>La formation au Fab Lab s’appuie sur des projets et le partage de connaissances : vous devez prendre"+
  " part à la capitalisation des connaissances et à l’instruction des autres utilisateurs.</p>"
  setting.save
end

unless Setting.find_by(name: 'about_title').try(:value)
  setting = Setting.find_or_initialize_by(name: 'about_title')
  setting.value = "Imaginer, Fabriquer, <br>Partager au Fab Lab <br> de La Casemate"
  setting.save
end

unless Setting.find_by(name: 'about_contacts').try(:value)
  setting = Setting.find_or_initialize_by(name: 'about_contacts')
  setting.value = "<dl>"+
  "<dt>Manager Fab Lab :</dt>"+
  "<dd>jean-michel.molenaar@lacasemate.fr</dd>"+
  "  <dt>Responsable médiation :</dt>"+
  "  <dd>catherine.demarcq@lacasemate.fr</dd>"+
  "    <dt>Animateur scientifique :</dt>"+
  "    <dd>diego.scharager@lacasemate.fr</dd>"+
  "    </dl>"+
  "<br><br>"+
  "<p><a href='http://lacasemate.fr'>Visitez le site de La Casemate</a></p>"
  setting.save
end

unless Setting.find_by(name: 'twitter_name').try(:value)
  setting = Setting.find_or_initialize_by(name: 'twitter_name')
  setting.value = "fablabgrenoble"
  setting.save
end

unless Setting.find_by(name: 'machine_explications_alert').try(:value)
  setting = Setting.find_or_initialize_by(name: 'machine_explications_alert')
  setting.value = "Tout achat d'heure machine est définitif. Aucune"+
  " annulation ne pourra être effectuée, néanmoins au plus tard 24h avant le créneau fixé, vous pouvez en"+
  " modifier la date et l'horaire à votre convenance et en fonction du calendrier proposé. Passé ce délais,"+
  " aucun changement ne pourra être effectué."
  setting.save
end

unless Setting.find_by(name: 'training_explications_alert').try(:value)
  setting = Setting.find_or_initialize_by(name: 'training_explications_alert')
  setting.value = "Toute réservation de formation est définitive."+
  " Aucune annulation ne pourra être effectuée, néanmoins au plus tard 24h avant le créneau fixé, vous pouvez"+
  " en modifier la date et l'horaire à votre convenance et en fonction du calendrier proposé. Passé ce délais,"+
  " aucun changement ne pourra être effectué."
  setting.save
end

unless Setting.find_by(name: 'subscription_explications_alert').try(:value)
  setting = Setting.find_or_initialize_by(name: 'subscription_explications_alert')
  setting.value = "<p><b>Règle sur la date de début des abonnements</b><br></p><ul><li>"+
  " <span style=\"font-size: 1.6rem; line-height: 2.4rem;\">Si vous êtes un nouvel utilisateur - i.e aucune "+
  " formation d'enregistrée sur le site - votre abonnement débutera à la date de réservation de votre première "+
  " formation.</span><br></li><li><span style=\"font-size: 1.6rem; line-height: 2.4rem;\">Si vous avez déjà une "+
  " formation ou plus de validée, votre abonnement débutera à la date de votre achat d'abonnement.</span></li>"+
  " </ul><p>Merci de bien prendre ses informations en compte, et merci de votre compréhension. L'équipe du Fab Lab.<br>"+
  " </p><p></p>"
  setting.save
end

unless Setting.find_by(name: 'event_reduced_amount_alert').try(:value)
  setting = Setting.find_or_initialize_by(name: 'event_reduced_amount_alert')
  setting.value = "* Tarif réduit si vous avez moins de 25 ans, que vous êtes étudiant ou demandeur d'emploi."
  setting.save
end


unless Setting.find_by(name: 'invoice_logo').try(:value)
  setting = Setting.find_or_initialize_by(name: 'invoice_logo')
  setting.value = "[encoded data, 27748 characters]"
  setting.save
end

unless Setting.find_by(name: 'invoice_reference').try(:value)
  setting = Setting.find_or_initialize_by(name: 'invoice_reference')
  setting.value = "YYMMmmmX[/VL]R[/A]"
  setting.save
end

unless Setting.find_by(name: 'invoice_code-active').try(:value)
  setting = Setting.find_or_initialize_by(name: 'invoice_code-active')
  setting.value = "true"
  setting.save
end

unless Setting.find_by(name: 'invoice_code-value').try(:value)
  setting = Setting.find_or_initialize_by(name: 'invoice_code-value')
  setting.value = "INMEDFABLAB"
  setting.save
end

unless Setting.find_by(name: 'invoice_order-nb').try(:value)
  setting = Setting.find_or_initialize_by(name: 'invoice_order-nb')
  setting.value = "nnnnnn-MM-YY"
  setting.save
end

unless Setting.find_by(name: 'invoice_VAT-active').try(:value)
  setting = Setting.find_or_initialize_by(name: 'invoice_VAT-active')
  setting.value = "false"
  setting.save
end

unless Setting.find_by(name: 'invoice_VAT-rate').try(:value)
  setting = Setting.find_or_initialize_by(name: 'invoice_VAT-rate')
  setting.value = "20.0"
  setting.save
end

unless Setting.find_by(name: 'invoice_text').try(:value)
  setting = Setting.find_or_initialize_by(name: 'invoice_text')
  setting.value = "Notre association n'est pas assujettie à la TVA"
  setting.save
end

unless Setting.find_by(name: 'invoice_legals').try(:value)
  setting = Setting.find_or_initialize_by(name: 'invoice_legals')
  setting.value = "La Casemate<br/>"+
                  "2 Place St Laurent 38000 GRENOBLE France<br/>"+
                  "Tél. Administration : +33 4 76 44 88 80<br/>"+
                  "Fax. : +33 4 76 42 76 66<br/>"+
                  "SIRET : 317 270 593 00013 - APE 913 E"
  setting.save
end

unless Setting.find_by(name: 'booking_window_start').try(:value)
  setting = Setting.find_or_initialize_by(name: 'booking_window_start')
  setting.value = "1970-01-01 08:00:00"
  setting.save
end

unless Setting.find_by(name: 'booking_window_end').try(:value)
  setting = Setting.find_or_initialize_by(name: 'booking_window_end')
  setting.value = "1970-01-01 23:59:59"
  setting.save
end

unless Setting.find_by(name: 'booking_move_enable').try(:value)
  setting = Setting.find_or_initialize_by(name: 'booking_move_enable')
  setting.value = 'true'
  setting.save
end

unless Setting.find_by(name: 'booking_move_delay').try(:value)
  setting = Setting.find_or_initialize_by(name: 'booking_move_delay')
  setting.value = '24'
  setting.save
end

unless Setting.find_by(name: 'booking_cancel_enable').try(:value)
  setting = Setting.find_or_initialize_by(name: 'booking_cancel_enable')
  setting.value = 'false'
  setting.save
end

unless Setting.find_by(name: 'booking_cancel_delay').try(:value)
  setting = Setting.find_or_initialize_by(name: 'booking_cancel_delay')
  setting.value = '24'
  setting.save
end

unless Setting.find_by(name: 'main_color').try(:value)
  setting = Setting.find_or_initialize_by(name: 'main_color')
  setting.value = '#cb1117'
  setting.save
end

unless Setting.find_by(name: 'secondary_color').try(:value)
  setting = Setting.find_or_initialize_by(name: 'secondary_color')
  setting.value = '#ffdd00'
  setting.save
end

Stylesheet.build_sheet!

unless Setting.find_by(name: 'training_information_message').try(:value)
  setting = Setting.find_or_initialize_by(name: 'training_information_message')
  setting.value = "Avant de réserver une formation, nous vous conseillons de consulter nos offres d'abonnement qui"+
                  " proposent des conditions avantageuses sur le prix des formations et les heures machines."
  setting.save
end


unless Setting.find_by(name: 'fablab_name').try(:value)
  setting = Setting.find_or_initialize_by(name: 'fablab_name')
  setting.value = 'Fab Lab de La Casemate'
  setting.save
end

unless Setting.find_by(name: 'name_genre').try(:value)
  setting = Setting.find_or_initialize_by(name: 'name_genre')
  setting.value = 'male'
  setting.save
end


unless DatabaseProvider.count > 0
  db_provider = DatabaseProvider.new
  db_provider.save

  unless AuthProvider.find_by(providable_type: DatabaseProvider.name)
    provider = AuthProvider.new
    provider.name = 'Fablab'
    provider.providable = db_provider
    provider.status = 'active'
    provider.save
  end
end
